<?php
/**
 * @package        Joomla.Site
 * @copyright    Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.
 * @license        GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('_JEXEC') or die;

//get copyright
$app = JFactory::getApplication();
$date        = JFactory::getDate();
$template = $app->getTemplate(true);
$params = $template->params;
$cur_year    = $date->format('Y');
$ytcopyright = $params->get('ytcopyright' );
$ytcopyright = str_replace('{year}', $cur_year, $ytcopyright);


//get language and direction
$doc = JFactory::getDocument();
$this->language = $doc->language;
$this->direction = $doc->direction;
?>

<html  lang="<?php echo $this->language; ?>" dir="<?php echo $this->direction; ?>">
<head>
    <title><?php echo $this->error->getCode(); ?> - <?php echo $this->title; ?></title>
    <meta content="text/html; charset=utf-8" http-equiv="content-type">
    <meta name="viewport" content="width=device-width,initial-scale=1,maximum-scale=1,user-scalable=no">
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
    <meta name="HandheldFriendly" content="true">
    <link type="text/css" href="http://fonts.googleapis.com/css?family=Raleway:200,300,400,500,600,700,800,900&subset=latin,latin-ext" rel="stylesheet">
    <link rel="stylesheet" href="<?php echo $this->baseurl.'/templates/'.$this->template; ?>/css/error.css" type="text/css" />
</head>
<body class="<?php echo $this->direction;?>">
<div class="container">
     <div class="content">
        <div class="text-404"><?php echo JText::_('TEXT_404'); ?></div>
        <div class="error-bot">
            <a class="btn return-home" href="<?php echo $this->baseurl; ?>/index.php" title="<?php echo JText::_('JERROR_LAYOUT_GO_TO_THE_HOME_PAGE'); ?>">
                <?php echo JText::_('TEXT_404_RETURN_HOMEPAGE'); ?>
            </a>
            <a class="btn return-home-mobile" href="<?php echo $this->baseurl; ?>/index.php" title="<?php echo JText::_('JERROR_LAYOUT_GO_TO_THE_HOME_PAGE'); ?>">
                <?php echo JText::_('TEXT_404_RETURN_HOMEPAGE_MOBILE'); ?>
            </a>
            <div class="mess-code"><?php echo $this->error->getMessage(); ?></div>
        </div>
    </div>
    <div id="techinfo">
        <span>
            <?php if ($this->debug) :
                echo $this->renderBacktrace();
            endif; ?>
        </span>
    </div>
</div>
</body>
</html>
