<?php
/**
 * @version    2.7.x
 * @package    K2
 * @author     JoomlaWorks http://www.joomlaworks.net
 * @copyright  Copyright (c) 2006 - 2016 JoomlaWorks Ltd. All rights reserved.
 * @license    GNU/GPL license: http://www.gnu.org/copyleft/gpl.html
 */

// no direct access
defined('_JEXEC') or die;

$yt_temp = JFactory::getApplication()->getTemplate();
include (JPATH_BASE . '/templates/'.$yt_temp.'/includes/placehold.php');

// Define default image size (do not change)
K2HelperUtilities::setDefaultImage($this->item, 'itemlist', $this->params);

?>

<!-- Start K2 Item Layout -->
<div class="catItemView catbg-color-<?php echo rand(1,6); ?> group<?php echo ucfirst($this->item->itemGroup); ?><?php if($this->item->params->get('pageclass_sfx')) echo ' '.$this->item->params->get('pageclass_sfx'); ?>">

	<!-- Plugins: BeforeDisplay -->
	<?php echo $this->item->event->BeforeDisplay; ?>

	<!-- K2 Plugins: K2BeforeDisplay -->
	<?php echo $this->item->event->K2BeforeDisplay; ?>
	<?php if($this->item->params->get('catItemImage')): ?>
		<!-- Item Image -->
		<div class="catItemImageBlock">
			<span class="catItemImage">
				<a href="<?php echo $this->item->link; ?>" title="<?php if(!empty($this->item->image_caption)) echo K2HelperUtilities::cleanHtml($this->item->image_caption); else echo K2HelperUtilities::cleanHtml($this->item->title); ?>">
					<?php 
					//Create placeholder items images
					$src = $this->item->image;
					$src_pre= $this->item->imageXLarge;
					if($this->item->imageWidth == '370'){
						$dk = "height: 225px;";
					}
					else{
						$dk = "height: auto;";
					}
					if (!empty( $src)) {								
						$thumb_img = '<img src="'.$src.'" alt="'.$this->item->title.'"style="width:'.$this->item->imageWidth.'px; '.$dk.'" />';
					} else if ($is_placehold) {					
						$thumb_img = yt_placehold($placehold_size['k2courses'],$this->item->title,$this->item->title);
					}	
					echo $thumb_img;
				?>
			  
			</a>
			</span>
			<div class="clr"></div>
		</div>
		<?php endif; ?>
	<div class="catItemCourses">
		<div class="bg-detail-top">
		  <?php if($this->item->params->get('catItemTitle')): ?>
		  <!-- Item title -->
		  <h3 class="catItemTitle">
				<a href="<?php echo $this->item->link; ?>">
		  		<?php echo limit_text($this->item->title, 3); ?>
		  	</a>
		  </h3>
		  <?php endif; ?>
			<div class="catItemHeaderInfo">

			<?php if($this->item->params->get('catItemCategory')): ?>
			<!-- Item category name -->
			<div class="catItemCt">
				<a href="<?php echo $this->item->category->link; ?>"><i class="ct-icon-folder"></i><?php echo $this->item->category->name; ?></a>
			</div>
			<?php endif; ?>

			<?php if($this->item->params->get('catItemRating')): ?>
			<!-- Item Rating -->
			<div class="itemRatingBlock">
				<div class="itemRatingForm">
					<ul class="itemRatingList">
						<li class="itemCurrentRating" id="itemCurrentRating<?php echo $this->item->id; ?>" style="width:<?php echo $this->item->votingPercentage; ?>%;"></li>
						<li><a href="#" data-id="<?php echo $this->item->id; ?>" title="<?php echo JText::_('K2_1_STAR_OUT_OF_5'); ?>" class="one-star">1</a></li>
						<li><a href="#" data-id="<?php echo $this->item->id; ?>" title="<?php echo JText::_('K2_2_STARS_OUT_OF_5'); ?>" class="two-stars">2</a></li>
						<li><a href="#" data-id="<?php echo $this->item->id; ?>" title="<?php echo JText::_('K2_3_STARS_OUT_OF_5'); ?>" class="three-stars">3</a></li>
						<li><a href="#" data-id="<?php echo $this->item->id; ?>" title="<?php echo JText::_('K2_4_STARS_OUT_OF_5'); ?>" class="four-stars">4</a></li>
						<li><a href="#" data-id="<?php echo $this->item->id; ?>" title="<?php echo JText::_('K2_5_STARS_OUT_OF_5'); ?>" class="five-stars">5</a></li>
					</ul>
					<div class="clr"></div>
				</div>
				<div class="clr"></div>
			</div>
			<?php endif; ?>

			<?php if($this->item->params->get('catItemCommentsAnchor') && ( ($this->item->params->get('comments') == '2' && !$this->user->guest) || ($this->item->params->get('comments') == '1')) ): ?>
				<!-- Anchor link to comments below -->
				<div class="catItemCm">
					<?php if(!empty($this->item->event->K2CommentsCounter)): ?>
						<!-- K2 Plugins: K2CommentsCounter -->
						<?php echo $this->item->event->K2CommentsCounter; ?>
					<?php else: ?>
						<?php if($this->item->numOfComments > 0): ?>
						<a href="<?php echo $this->item->link; ?>#itemCommentsAnchor">
							<?php echo $this->item->numOfComments; ?> <?php echo '('. '&nbsp;' .$this->item->numOfComments . '&nbsp;' . JText::_('REVIEWS_TEXT'). '&nbsp;'.')'; ?>
						</a>
						<?php else: ?>
						<a href="<?php echo $this->item->link; ?>#itemCommentsAnchor">
							<?php echo '('. '&nbsp;' .$this->item->numOfComments . '&nbsp;' . JText::_('REVIEW_TEXT'). '&nbsp;'.')'; ?>
						</a>
						<?php endif; ?>
					<?php endif; ?>
				</div>
			<?php endif; ?>
	  </div>

	  <!-- Plugins: AfterDisplayTitle -->
	  <?php echo $this->item->event->AfterDisplayTitle; ?>

	  <!-- K2 Plugins: K2AfterDisplayTitle -->
	  <?php echo $this->item->event->K2AfterDisplayTitle; ?>

	  <div class="catItemBody">

		  <!-- Plugins: BeforeDisplayContent -->
		  <?php echo $this->item->event->BeforeDisplayContent; ?>

		  <!-- K2 Plugins: K2BeforeDisplayContent -->
		  <?php echo $this->item->event->K2BeforeDisplayContent; ?>

		  <?php if($this->item->params->get('catItemIntroText')): ?>
		  <!-- Item introtext -->
		  <div class="catItemIntroText">
		  	<?php //echo $this->item->introtext; ?>
		  	<?php echo limit_text($this->item->introtext, 25); ?>
		  </div>
		  <?php endif; ?>

			<div class="clr"></div>

		  <!-- Plugins: AfterDisplayContent -->
		  <?php echo $this->item->event->AfterDisplayContent; ?>

		  <!-- K2 Plugins: K2AfterDisplayContent -->
		  <?php echo $this->item->event->K2AfterDisplayContent; ?>

	  </div>
  </div>


	<?php if ($this->item->params->get('catItemReadMore')): ?>
	<!-- Item "read more..." link -->
	<div class="item-apply">
		<a href="index.php/contact"><i class="item-icon-apply"></i><?php echo JText::_('APPLY_TEXT'); ?></a>
	</div>
	<?php endif; ?>
	</div>

  <!-- Plugins: AfterDisplay -->
  <?php echo $this->item->event->AfterDisplay; ?>

  <!-- K2 Plugins: K2AfterDisplay -->
  <?php echo $this->item->event->K2AfterDisplay; ?>

	<div class="clr"></div>
	<?php $fieldscourses = $this->item->extra_fields; ?>
	<?php if($this->item->params->get('catItemExtraFields') && count($this->item->extra_fields)): ?>
	<?php if( (isset($fieldscourses[0]) && ($fieldscourses[0]->value =='$0.00'))){?>
		<div class="item-price-bg"><div class="item-price-text"><?php echo JText::_('EXTRA_FIELDS_PRICE_FREE'); ?></div></div>
	<?php }elseif((isset($fieldscourses[1]) && ($fieldscourses[1]->value =='$0.00'))){ ?>
		<div class="item-price-bg"><div class="item-price-text font-size-14"><?php echo $fieldscourses[0]->value; ?></div></div>
	<?php }else{ ?>
		<div class="item-price-bg"><div class="item-price-text font-size-14"><?php echo $fieldscourses[1]->value; ?></div></div>
	<?php } ?>
	<?php endif; ?>
</div>
<!-- End K2 Item Layout -->
