<?php
/*
 * @package Sj K2 Ajax Tabs
 * @version 3.0.0
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @copyright (c) 2015 YouTech Company. All Rights Reserved.
 * @author YouTech Company http://www.smartaddons.com
 *
 */
defined('_JEXEC') or die;

JHtml::stylesheet('modules/' . $module->module . '/assets/css/style.css');
if (!defined ('JQUERY_UI'))
{
    JHtml::stylesheet('modules/' . $module->module . '/assets/css/jquery-ui.css');
    JHtml::script('modules/' . $module->module . '/assets/js/jquery-ui.js');
    define( 'JQUERY_UI', 1 );
}
$uniqueid = 'sjk2filter_' . $module->id;
$options = $params->toObject();

$itemid             = $params->get ('itemid');
$show_keyword       = $params->get ('show_keyword');
$show_categories    = $params->get ('show_categories');
$show_date      = $params->get ('show_date');
$cls = rand().time();
// check category loaded
if ($params->get('pretext', '') != ''): ?>
    <div class="pre-text"><?php echo $params->get('pretext'); ?></div>
    <?php
endif; ?>
<!--[if lt IE 9]>
<div class="sj-k2-filter msie lt-ie9" id="<?php echo $uniqueid; ?>"><![endif]-->
<!--[if IE 9]>
<div class="sj-k2-filter msie" id="<?php echo $uniqueid; ?>"><![endif]-->
<!--[if gt IE 9]><!-->
<div class="sj-k2-filter" id="<?php echo $uniqueid; ?>"><!--<![endif]-->
    <form action="<?php echo $action; ?>" method="get" class="form-inline">
        <div class="form-group">
            <?php if($show_keyword == 1) { ?>
            <input class="form-control input-filter cl-filter text-filter" value="<?php echo JRequest::getVar('searchword');?>" id="searchword-<?php echo $cls;?>" name="searchword" Placeholder="Keywords" type="text">
            <?php } if($show_categories == 1) { ?>
            <select id="categories-<?php echo $cls;?>" class="input-filter input-cat cl-filter filtercategories" name="categories">
                <option selected value="*"><?php echo JText::_('K2_FILTER_ALL_CATEGORIES');?></option>
                <?php foreach($list as $item):?>
                    <option value="<?php echo $item->id; ?>" <?php if($item->id == JRequest::getVar('categories')) echo 'selected="selected"'; ?>><?php echo $item->name;?></option>
                <?php endforeach;?>
            </select>
            <?php } if($show_date == 1) { ?>
            <input class="form-control input-filter input-date cl-filter" value="<?php echo JRequest::getVar('created-from');?>" id="created-from-<?php echo $cls;?>" name="created-from" Placeholder="Date From" type="text">
            <input class="form-control input-filter input-date cl-filter" value="<?php echo JRequest::getVar('created-to');?>" id="created-to-<?php echo $cls;?>" name="created-to" Placeholder="Date To" type="text">
            <?php } ?>
            <input class="btn btn-primary  btn-submit cl-filter" type="submit" value="<?php echo JText::_('K2_FILTER_SUBMIT');?>" />
            <!--<button class="btn btn-primary" type="submit"><?php /*echo JText::_('K2_FILTER_SUBMIT');*/?></button>-->
        </div>
        <input type="hidden" name="moduleId" value="<?php echo $module->id;?>" />
        <input type="hidden" name="Itemid" value="<?php echo $itemid;?>" />

    </form>

</div>
<?php
if ($params->get('posttext', '') != ''): ?>
    <div class="post-text"><?php echo $params->get('posttext'); ?></div>
    <?php
endif; ?>
<script type="text/javascript">
    jQuery(function($) {
        $( "#created-from-<?php echo $cls;?>, #created-to-<?php echo $cls;?>" ).datepicker({
            dateFormat:"yy-mm-dd",
            changeMonth: true,
            changeYear: true,
            showButtonPanel: true,
            buttonImageOnly: false,
        });
    });
</script>